var EntryList;
var EntryDesc;
var cqrPlugTree = '';
var cqrPlugTreeView = '';
var cqrPlugArr = new Array();
var cqrPlugNameClicked = false;
var cqrCurDirId = '';
var cqrCurDirParentId = '';
var cqrCopiedId = '';
var cqrCutId = '';

function init(){
  EntryDesc    = document.getElementById('Desc');
	window.setTimeout('initWithDelay();', 0);
  //window.sizeToContent();
}

function initWithDelay(){
  cqrCurDirId = cqrFS.menuRootId;
  cqrPlugArr = cqrFS.getIndexedDirEntries(cqrFS.menuRootId);
  cqrInitTree(cqrPlugArr);
  
  ///cqrPlugTree = document.getElementById("cqrPlugTree");
  ///cqrPlugTreeView.rowCount = cqrPlugArr.length;
  ///cqrPlugTreeView._plugStore = cqrPlugArr;
  ///cqrPlugTree.view = cqrPlugTreeView;
  /////cqrPlugTreeView._init();

  cqrUpButtonCheck();

  fillprefstab();
  window.sizeToContent();
  checkHotMenuStatus();
}

function cqrInitTree(plugArr){
    cqrPlugTreeView = new cqrPlugTreeView2;
    cqrPlugTreeView.rowCount = cqrPlugArr.length;
    cqrPlugTreeView._plugStore = cqrPlugArr;
    cqrPlugTree = document.getElementById("cqrPlugTree");
    cqrPlugTree.view = cqrPlugTreeView;
}


function cqrCopy(event){
    seldId = cqrPlugTreeView.getSelectedIndex();
    if (seldId < 0) return;
    item = cqrPlugArr[seldId];
    if (item.isDir) return;
    cqrCutId = '';
    cqrCopiedId = item.id;
    cqrLog.debug('Copied: ' + item.filepath);
}

function cqrCut(event){
    seldId = cqrPlugTreeView.getSelectedIndex();
    if (seldId < 0) return;
    item = cqrPlugArr[seldId];
    if (item.isDir) return;
    cqrCopiedId = '';
    cqrCutId = item.id;
    cqrLog.debug('Cut: ' + item.filepath);
}

function cqrCheckCopy(){
    seldId = cqrPlugTreeView.getSelectedIndex();
    if (seldId < 0) return;
    item = cqrPlugArr[seldId];
}

function cqrCheckCopyPaste(){
    seldId = cqrPlugTreeView.getSelectedIndex();
    if (cqrCopiedId || cqrCutId){
        document.getElementById('cqrPaste').setAttribute('disabled', false);
    } else {
        document.getElementById('cqrPaste').setAttribute('disabled', true);
    }

    
    if (seldId < 0) {
        document.getElementById('cqrCopy').setAttribute('disabled', true);
        document.getElementById('cqrCut').setAttribute('disabled', true);
        return;
    }
    
    item = cqrPlugArr[seldId];
    if (item.isDir){
        document.getElementById('cqrCopy').setAttribute('disabled', true);
        document.getElementById('cqrCut').setAttribute('disabled', true);
    } else {
        document.getElementById('cqrCopy').setAttribute('disabled', false);
        document.getElementById('cqrCut').setAttribute('disabled', false);
    }
}

function cqrPaste(){
    if (cqrCopiedId && cqrCutId){
        cqrCopiedId = '';
        cqrCutId = '';
        return;
    }
    if (cqrCopiedId){
        itemId = cqrCopiedId;
        cqrFS.move(itemId, cqrCurDirId, true);
        cqrCopiedId = '';
        cqrReloadTree();
        cqrLog.debug('CopyPasted: ' + item.filepath);
        return;
    } else if (cqrCutId) {
        itemId = cqrCutId;
        cqrFS.move(itemId, cqrCurDirId, false);
        cqrCutId = '';
        cqrReloadTree();
        cqrLog.debug('Cun-n-Pasted: ' + item.filepath);
        return;
    } else {
        cqrCopiedId = '';
        cqrCutId = '';
        return;
    }
}


function cqrDelete(event){
    seldId = cqrPlugTreeView.getSelectedIndex();
    if (seldId < 0) return;
    item = cqrPlugArr[seldId];
    deleted = cqrFS.delFile(item.id);
    if (deleted) cqrReloadTree();
}

function cqrCreate(isDir){
    var dirName = '';
    if (cqrCurDirId == cqrFS.menuRootId) {
        dirName = cqrFS.usrMenuRootDir || cqrFS.sysMenuRootDir;
    } else {
        dirName = cqrFS.decomposeId(cqrCurDirId)
    }
    
    if (!dirName) {
        cqrLog.err('Menu root dirs not set!');
        return;
    }
    
    cqrFS.create(isDir, dirName);
    cqrReloadTree();
}

function cqrTreeKeyPress(event){
    //cqrLog.warn('>>>>>>> ' + event.charCode);
    //cqrLog.warn('>>>>>>> ' + event.keyCode);
    l10nCharCodeR = parseInt(cqrMess.GetStringFromName('cqr.cfg.l10nCharCodeR'));
    l10nCharCodeC = parseInt(cqrMess.GetStringFromName('cqr.cfg.l10nCharCodeC'));
    l10nCharCodeX = parseInt(cqrMess.GetStringFromName('cqr.cfg.l10nCharCodeX'));
    l10nCharCodeV = parseInt(cqrMess.GetStringFromName('cqr.cfg.l10nCharCodeV'));
    l10nCharCodeN = parseInt(cqrMess.GetStringFromName('cqr.cfg.l10nCharCodeN'));
    
    if (event.keyCode == 13) {
        // Enter
        event.preventDefault();
        changeDir();
        return;
    } else if (event.keyCode == 8) {
        //Backspace
        event.preventDefault();
        cqrDirUp();
        return;
    } else if (event.keyCode == 46) {
        //Backspace
        event.preventDefault();
        cqrDelete(event);
        return;
    } else if ((event.charCode == 114 && event.ctrlKey) ||
               (event.charCode == l10nCharCodeR && event.ctrlKey) ||
               event.keyCode == 116) {
        //Ctrl+R or F5
        event.preventDefault();
        cqrReloadTree();
        return;
    } else if ((event.charCode == 99 && event.ctrlKey) ||
               (event.charCode == l10nCharCodeC && event.ctrlKey) ||
               event.keyCode == 116) {
        //Ctrl+C
        event.preventDefault();
        cqrCopy(event);
        return;
    } else if ((event.charCode == 120 && event.ctrlKey) ||
               (event.charCode == l10nCharCodeX && event.ctrlKey) ||
               event.keyCode == 116) {
        //Ctrl+X
        event.preventDefault();
        cqrCut(event);
        return;
    } else if ((event.charCode == 118 && event.ctrlKey) ||
               (event.charCode == l10nCharCodeV && event.ctrlKey) ||
               event.keyCode == 116) {
        //Ctrl+V
        event.preventDefault();
        cqrPaste();
        return;
    } else if ((event.charCode == 110 && event.ctrlKey) ||
               (event.charCode == l10nCharCodeN && event.ctrlKey) ||
               event.keyCode == 116) {
        //Ctrl+N
        event.preventDefault();
        cqrCreate(true);
        return;
    } 
}

function cqrTreeSelectDoubleClick(event){
    if (event.keyCode != 13 && event.button != 0) return;
    if (event.originalTarget.localName != 'treechildren') return;
    changeDir();
}

function changeDir(){
    seldId = cqrPlugTreeView.getSelectedIndex();
    if (seldId < 0) return;
    item = cqrPlugArr[seldId];
    if (!item.isDir) return;
    
    cqrCurDirId = item.id;
    cqrUpButtonCheck();
    cqrPlugArr = cqrFS.getIndexedDirEntries(item.id);
    cqrInitTree(cqrPlugArr);
    EntryDesc.value = '';

}

function cqrUpButtonCheck(){
    button = document.getElementById('cqrUpButton');
    if (cqrCurDirId == cqrFS.menuRootId) {
        button.disabled = true;
    } else {
        button.disabled = false;
    }
}

function cqrDirUp(){
    if (cqrCurDirId == cqrFS.menuRootId) return;
    item = cqrFS.cachedItems[cqrCurDirId];
    cqrPlugArr = cqrFS.getIndexedDirEntries(item.parent);
    
    cqrInitTree(cqrPlugArr);
    //cqrPlugTreeView.rowCount = cqrPlugArr.length;
    //cqrPlugTreeView._plugStore = cqrPlugArr;
    //cqrPlugTree.view = cqrPlugTreeView;

    cqrCurDirId = item.parent;
    cqrUpButtonCheck();
    EntryDesc.value = '';
}

function cqrReloadTree(){
    if (cqrCurDirId == cqrFS.menuRootId){
        cqrPlugArr = cqrFS.getIndexedDirEntries(cqrFS.menuRootId);
    } else {
        item = cqrFS.cachedItems[cqrCurDirId];
        cqrPlugArr = cqrFS.getIndexedDirEntries(item.id);
    }
    cqrInitTree(cqrPlugArr);
    //cqrPlugTreeView.rowCount = cqrPlugArr.length;
    //cqrPlugTreeView._plugStore = cqrPlugArr;
    //cqrPlugTree.view = cqrPlugTreeView;
    //document.getElementById("cqrPlugTree").focus();
    EntryDesc.value = '';
    cqrUpButtonCheck();
}

function cqrTreeSelect(){
    index = cqrPlugTree.currentIndex;
    item = cqrPlugArr[index];
    if (!item) return;
    var desctext = "";

    if (item.isDir) {
        desctext = cqrMess.GetStringFromName('cqr.FS.dir') + 
        ' "' + item.Title + '":\n' + item.filepath +
        '\n\n' + cqrMess.GetStringFromName('cqr.FS.exploreDir');
    } else {
        desctext = item.Title + ":\n" +
        item.Desc + "\n" +
        item.filepath;
        if (item.showif) desctext += cqrMess.GetStringFromName('cqr.cfg.descrSI') + item.showif + " " + cqrMess.GetStringFromName('cqr.cfg.descrSIfound') + item.sitarget;
        desctext += cqrMess.GetStringFromName('cqr.cfg.descrInps') + "Action = " + item.Action + "\n";
        for (i in item.Inputs){
            desctext += i+" = "+item.Inputs[i].value +"\n";
            if (item.Inputs[i].list){
                for (v in item.Inputs[i].list) desctext += " " + cqrMess.GetStringFromName('cqr.cfg.descrInpsOr') + " " + item.Inputs[i].list[v].value + "\n";
            }
        }
    }
    EntryDesc.value = desctext;
}

function checkHotMenuStatus(){
    if (document.getElementById('enhotmenu').checked){
        document.getElementById('hotmenu_style').disabled = false;
        document.getElementById('MCDelayOn_lbl').disabled = false;
        document.getElementById('MCDelayOn_tb').disabled = false;
        document.getElementById('MCDelayOn_lblms').disabled = false;
        document.getElementById('MCDelayOff_lbl').disabled = false;
        document.getElementById('MCDelayOff_tb').disabled = false;
        document.getElementById('MCDelayOff_lblms').disabled = false;
        document.getElementById('hotmenuNote').disabled = false;
    } else {
        document.getElementById('hotmenu_style').disabled = true;
        document.getElementById('MCDelayOn_lbl').disabled = true;
        document.getElementById('MCDelayOn_tb').disabled = true;
        document.getElementById('MCDelayOn_lblms').disabled = true;
        document.getElementById('MCDelayOff_lbl').disabled = true;
        document.getElementById('MCDelayOff_tb').disabled = true;
        document.getElementById('MCDelayOff_lblms').disabled = true;
        document.getElementById('hotmenuNote').disabled = true;
    }

    if (document.getElementById('enhotmenu').checked && document.getElementById('middleclick').selected){
        document.getElementById('MCDelayOn_lbl').disabled = false;
        document.getElementById('MCDelayOn_tb').disabled = false;
        document.getElementById('MCDelayOn_lblms').disabled = false;
        document.getElementById('MCDelayOff_lbl').disabled = false;
        document.getElementById('MCDelayOff_tb').disabled = false;
        document.getElementById('MCDelayOff_lblms').disabled = false;
        document.getElementById('hotmenuNote').disabled = false;
    } else {
        document.getElementById('MCDelayOn_lbl').disabled = true;
        document.getElementById('MCDelayOn_tb').disabled = true;
        document.getElementById('MCDelayOn_lblms').disabled = true;
        document.getElementById('MCDelayOff_lbl').disabled = true;
        document.getElementById('MCDelayOff_tb').disabled = true;
        document.getElementById('MCDelayOff_lblms').disabled = true;
        document.getElementById('hotmenuNote').disabled = true;
    }

}

function fillprefstab() {
	document.getElementById('prfs_plugsdir').value = cqrEnv.PlugsDir;
    document.getElementById('prfs_plugsdir2').value = cqrEnv.PlugsDir2;
	document.getElementById('enhotmenu').checked = cqrEnv.UseHotMenu;
	document.getElementById('HTTPIcon').checked = cqrEnv.HTTPIcon;
	document.getElementById('hidefromtools').checked = cqrEnv.HideFromTools;
	document.getElementById('cspInMainMenu').checked = cqrEnv.ShowCSPInMainMenu;
    document.getElementById('cqrHideQueryTo').checked = cqrEnv.HideQueryTo;
	document.getElementById('MainContextLimit').value = cqrEnv.MainContextLimit;
    document.getElementById('MCDelayOn_tb').value = cqrEnv.MiddleClickDelayms;
    document.getElementById('MCDelayOff_tb').value = cqrEnv.MiddleClickHidems;
    document.getElementById('cqrLogLevel').selectedIndex = cqrEnv.LogLevel;
    
    if (cqrEnv.UseCtrlForHM) {
        document.getElementById('hotmenu_style').selectedItem = document.getElementById('ctrlshift');
    } else {
        document.getElementById('hotmenu_style').selectedItem = document.getElementById('middleclick');
    }

	switch (cqrEnv.OpenRes)
	{
		case 'tab_bg':
		    document.getElementById('open_res').selectedIndex = 0;
		    break;
		case 'tab_fg':
		    document.getElementById('open_res').selectedIndex = 1;
		    break;
		case 'win_bg':
		    document.getElementById('open_res').selectedIndex = 2;
		    break;
		case 'win_fg':
		    document.getElementById('open_res').selectedIndex = 3;
		    break;
		case 'same_win':
		    document.getElementById('open_res').selectedIndex = 4;
		    break;
	}
}

function cqrprfs_SaveMain() {
    cqrEnv.PlugsDir = document.getElementById("prfs_plugsdir").value;
    cqrEnv.PlugsDir2 = document.getElementById("prfs_plugsdir2").value;
    // Hot menu section
    cqrEnv.UseHotMenu = document.getElementById("enhotmenu").checked;
    cqrEnv.UseCtrlForHM = document.getElementById('ctrlshift').selected;
    cqrEnv.UseMiddleClickForHM = document.getElementById('middleclick').selected;
    cqrEnv.MiddleClickDelayms = document.getElementById('MCDelayOn_tb').value;
    cqrEnv.MiddleClickHidems = document.getElementById('MCDelayOff_tb').value;
    // HM section end
    cqrEnv.HTTPIcon = document.getElementById("HTTPIcon").checked;
    cqrEnv.OpenRes = document.getElementById("open_res").selectedItem.id;
    cqrEnv.HideFromTools = document.getElementById('hidefromtools').checked;
    cqrEnv.ShowCSPInMainMenu = document.getElementById('cspInMainMenu').checked;
    cqrEnv.HideQueryTo = document.getElementById('cqrHideQueryTo').checked;
    cqrEnv.MainContextLimit = document.getElementById('MainContextLimit').value;
    cqrEnv.LogLevel = document.getElementById('cqrLogLevel').selectedIndex;
    cqrPref.saveMain();
}


function ExecQuery(ctrl, id){
try{
  window.opener.top.cqrConfigLastWillId = EntryList.selectedItem.getAttribute('value');
  window.opener.top.cqrConfigLastWillCtrl = ctrl;
  window.close();
}catch(er){cqrLog.err(er, "ExecQuery sub")}
}


function getPlugsFolder(field){
  var folderPicker = Components.interfaces.nsIFilePicker;
  var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(folderPicker);
  fp.init(window, "", folderPicker.modeGetFolder);
  var res = fp.show();
  if (res == folderPicker.returnOK) {
    document.getElementById(field).value = fp.file.path;
  }
}


var cqrPlugTreeView2 = function() {
    this._plugStore = '';
    this._currienDirId = cqrFS.menuRootId;
    this._AtomSrv = atomSrv = Components.classes["@mozilla.org/atom-service;1"].createInstance(Components.interfaces.nsIAtomService);
    this.rowCount = 0;
    this.treebox = null;
    
    this._init = function plugTree_init(){
        //cqrPlugTreeView.rowCount = cqrPlugArr.length;
        //this._plugStore = cqrPlugArr;
    }

    this._movePlug = function plugTreeView_movePlug(step) {
        var from = this.getSelectedIndex();
        var to = from - step;    
        var plugs = this._plugStore;
        if (to < 0 || to > plugs.length - 1) return;

        var tmp = plugs.splice(from, 1)[0];
        plugs.splice(to, 0, tmp);
        
        for (each in plugs) {
            cqrFS.setItemProp(plugs[each].id, 'OrderInMenu', parseFloat(each), true);
        }
        //cqrFS.setItemProp(this._plugStore[from].id, 'OrderInMenu', to, true);
        //cqrFS.setItemProp(this._plugStore[to].id, 'OrderInMenu', to, true);
        
        this.treebox.invalidate();
        this.selection.select(to);
        this.treebox.ensureRowIsVisible(to);
        document.getElementById("cqrPlugTree").focus();
    }

    this.getSelectedIndex = function() {
        var seln = this.selection;
        if (seln.getRangeCount() > 0) {
            var min = { };
            seln.getRangeAt(0, min, { });
            return min.value;
        }
        return -1;
    }
    
    this.getCellText = function(index, column) {
        if (column.id == "plugName") {
            //cqrLog.warn('Getting plugname ' + this._plugStore[index].Title);
            return this._plugStore[index].Title;
        }
        return '';
    }

    this.getImageSrc = function(index, column) {
        if (column.id == "plugName"){
            //moz-icon://
            item = this._plugStore[index];
            if (item.isDir) {
                return 'chrome://conquery/skin/folder-item.png?size=16';
            } else {
                if ((!item.showif) && (item.raw_icon)){
                    //uncomment this to have plugin icons in config tree
                    //return item.raw_icon;
                    return 'chrome://conquery/skin/no-icon.png?size=16';
                } else if (item.showif) {
                    return 'chrome://conquery/skin/context.png?size=16';
                } else {
                    return 'chrome://conquery/skin/no-icon.png?size=16';
                }
            }
        }
        if (column.id == "plugType"){
            item = this._plugStore[index];
            if (item.isDir) {
                return 'chrome://conquery/skin/folder-classic.png?size=16';
            } else {
                if (item.PluginType == 'ConQuery'){
                    return 'chrome://conquery/skin/ico-ConQuery.png';
                } else if (item.PluginType == 'Mycroft') {
                    return 'chrome://conquery/skin/ico-Mycroft.png?size=16';
                } else if (item.PluginType == 'MozillaSearch') {
                    return 'chrome://conquery/skin/ico-Mozilla.png';
                } else if (item.PluginType == 'OpenSearch') {
                    return 'chrome://conquery/skin/ico-OpenSearch.png?size=16';
                }
            }
        }
    }

    this.getCellProperties = function(row, column, prop) {
        if (!this._plugStore[row]) return;
        if (column.id == "plugName"){
            var isDir = this._AtomSrv.getAtom("isDir");
            var isFile = this._AtomSrv.getAtom("isFile");
            if (this._plugStore[row].isDir){
                prop.AppendElement(isDir);
            } else {
                prop.AppendElement(isFile);
            }
        } else if (column.id == "plugShow") {
            if (!this._plugStore[row].showif){
                var show = this._AtomSrv.getAtom("cqrchecked");
                var hide = this._AtomSrv.getAtom("cqrunchecked");
                if (this._plugStore[row].ShowInMenu){
                    prop.AppendElement(show);
                } else {
                    prop.AppendElement(hide);
                }
            } else {
                var show = this._AtomSrv.getAtom("cqrcontext_checked");
                var hide = this._AtomSrv.getAtom("cqrcontext_unchecked");
                if (this._plugStore[row].ShowInMenu){
                    prop.AppendElement(show);
                } else {
                    prop.AppendElement(hide);
                }
            }
        }
        if (column.id == "plugType"){
            //item = this._plugStore[row];
            //if (item.isDir) {
            //    return 'cqrFolderType';
            //} else {
            //    if (item.PluginType == 'ConQuery'){
            //        return 'cqrConQueryType';
            //    } else if (item.PluginType == 'Mycroft') {
            //        return 'cqrMycroftType';
            //    } else if (item.PluginType == 'MozillaSearch') {
            //        return 'cqrMozillaType';
            //    } else if (item.PluginType == 'OpenSearch') {
            //        return 'cqrOpenSearchType';
            //    }
            //}
        }
    }
    
    this.isEditable = function(){
        return true;
    }

    this.getCellValue = function(row, column) {
        if (column.id == "plugShow") {
            if (this._plugStore[row].ShowInMenu) return true;
        }
    }
    
    this.setCellValue = function(row, col, value){
        if (value == 'false'){
            this._plugStore[row].ShowInMenu = false;
            cqrFS.setItemProp(this._plugStore[row].id, 'ShowInMenu', false, true);
        } else {
            this._plugStore[row].ShowInMenu = true;
            cqrFS.setItemProp(this._plugStore[row].id, 'ShowInMenu', true, true);
        }
    }

    this.setTree = function(treebox){ this.treebox = treebox; }
    this.isContainer = function(row){ return false; }
    this.isSeparator = function(row){ return false; }
    this.isSorted = function(){ return false; }
    this.getLevel = function(row){ return 0; }
    this.getRowProperties = function(row,props){}
    this.getColumnProperties = function(colid,col,props){}
    this.cycleHeader = function(){}
};